"Change Set:		7570ST80-ar.50

ST80-ar.50:
Another round of reducing MVC/Morphic dependencies:
- Remove the durable menus which created a cyclic dependency between MVC, Utilities, and Morphic
- Provide StandardSystemView>>isWindowForModel:

"!
!StandardSystemView methodsFor: 'framing' stamp: 'ar 8/15/2009 14:57'!
collapse
	"If the receiver is not already collapsed, change its view to be that of its 
	label only."

	self isCollapsed ifFalse:
			[model modelSleep.
			expandedViewport := self viewport.
			savedSubViews := subViews.
			self resetSubViews.
			labelText isNil ifTrue: [self label: nil.  bitsValid := false.].
			self window: (self inverseDisplayTransform:
					((self labelDisplayBox topLeft extent: (labelText extent x + 70) @ self labelHeight)
						 intersect: self labelDisplayBox))]! !

!ScreenController methodsFor: 'nested menus' stamp: 'ar 8/15/2009 14:59'!
changesMenu
	"Answer a menu for changes-related items"
	^ SelectionMenu labelList:
		#(
			'simple change sorter'
			'dual change sorter'

			'file out current change set'
			'create new change set...'
			'browse changed methods'
			'check change set for slips'

			'isolate methods of this project'
			'propagate changes above'

			'browse recent submissions'
			'recently logged changes...'
			'recent log file...'
			)
		lines: #(1 3 7 9)
		selections: #(
openSimpleChangeSorter openChangeManager
fileOutChanges newChangeSet browseChangedMessages lookForSlips
beIsolated propagateChanges
browseRecentSubmissions browseRecentLog fileForRecentLog)
"
ScreenController new changesMenu startUp
"! !

!StandardSystemView methodsFor: 'testing' stamp: 'ar 8/15/2009 15:05'!
isWindowForModel: aModel
	"Return true if the receiver acts as the window for the given model"
	^aModel == self model! !

!ScreenController methodsFor: 'nested menus' stamp: 'ar 8/15/2009 15:01'!
helpMenu 
	"Answer the help menu to be put up as a screen submenu"

	^ SelectionMenu labelList:
		#(
			'about this system...'
			'update code from server'
			'preferences...'

			'command-key help'
			'font size summary'
			'useful expressions'
			'view graphical imports'
			'standard graphics library'),

			(Array with: (Preferences soundsEnabled
							ifFalse: ['turn sound on']
							ifTrue: ['turn sound off'])) ,

		#(	'set author initials...'
			'vm statistics'
			'space left')
		lines: #(1 4 6 11)
		selections: #( aboutThisSystem absorbUpdatesFromServer
editPreferences  openCommandKeyHelp fontSizeSummary openStandardWorkspace viewImageImports
standardGraphicsLibrary soundOnOrOff setAuthorInitials vmStatistics garbageCollect)
"
ScreenController new helpMenu startUp
"! !

!ScreenController methodsFor: 'nested menus' stamp: 'ar 8/15/2009 14:56'!
appearanceMenu 
	"Answer the appearance menu to be put up as a screen submenu"

	^ SelectionMenu labelList:
		#(
			'system fonts...'
			'full screen on'
			'full screen off'
			'set display depth...'
			'set desktop color...' ) 

		lines: #(2 4)
		selections: #(configureFonts
fullScreenOn fullScreenOff setDisplayDepth setDesktopColor)
"
ScreenController new appearanceMenu startUp
"! !

!ScreenController methodsFor: 'nested menus' stamp: 'ar 8/15/2009 14:59'!
projectScreenMenu
	"Answer the project screen menu."

	^ SelectionMenu labelList:
		#(

			'previous project'
			'jump to project...'
			'restore display'

			'open...'
			'windows...'
			'changes...'
			'help...'
			'appearance...'
			'do...'

			'save'
			'save as...'
			'save and quit'
			'quit')
		lines: #(1 4 10)
		selections: #(
returnToPreviousProject jumpToProject restoreDisplay
presentOpenMenu presentWindowMenu presentChangesMenu presentHelpMenu presentAppearanceMenu commonRequests
snapshot saveAs snapshotAndQuit quit )
"
ScreenController new projectScreenMenu startUp
"! !

!ScreenController methodsFor: 'nested menus' stamp: 'ar 8/15/2009 15:00'!
windowMenu
	"Answer a menu for windows-related items.  "

	^ SelectionMenu labelList:
		#(
			'find window...'
			'find changed browsers...'
			'find changed windows...'

			'collapse all windows'
			'expand all windows'
			'close unchanged windows' ) , 
			(Array
				with: self bitCachingString
				with: self staggerPolicyString)
		lines: #(1 4 7)
		selections: #(
findWindow chooseDirtyBrowser chooseDirtyWindow
collapseAll expandAll closeUnchangedWindows
fastWindows changeWindowPolicy)
"
ScreenController new windowMenu startUp
"! !

!ScreenController methodsFor: 'nested menus' stamp: 'ar 8/15/2009 15:00'!
openMenu
	^ SelectionMenu labelList:
		#(

			'browser'
			'package browser'
			'method finder'
			'workspace'
			'file list'
			'file...'
			'transcript'
			'morphic world'

			'simple change sorter'
			'dual change sorter'

			'mvc project'
			)
		lines: #(1 9 11)
		selections: #(
openBrowser openPackageBrowser openSelectorBrowser openWorkspace openFileList openFile openTranscript
openSimpleChangeSorter openChangeManager
openProject  openMorphicProject  )
"
ScreenController  new openMenu startUp
"! !

ScreenController removeSelector: #durableOpenMenu!
ScreenController removeSelector: #openMorphicWorld!
ScreenController removeSelector: #durableChangesMenu!
ScreenController removeSelector: #durableWindowMenu!
ScreenController removeSelector: #durableScreenMenu!
ScreenController removeSelector: #windowSpecificationPanel!
ScreenController removeSelector: #durableHelpMenu!
