"Change Set:		7679KernelTests-laza.88

KernelTests-laza.88:
Only remove obsolete BlockContext tests that fail

KernelTests-laza.86:
vm clocks seem to work differently across platforms. The following gives different results on windows (always 0) and linux (0 and 1).

50 timesRepeat: [Transcript show: (Time dateAndTimeNow last asSeconds - Time now asSeconds) printString; cr].

This is the reason TimeTest>>#testGeneralInquiries is nondeterministic.on linux.

This adjusts the test by introducing an epsilon.

"!
!BlockContextTest methodsFor: 'tests' stamp: 'laza 8/31/2009 01:45'!
testSetUp
	"Note: In addition to verifying that the setUp worked the way it was expected to, testSetUp is used to illustrate the meaning of the simple access methods, methods that are not normally otherwise 'tested'"
	self deny: aBlockContext isMethodContext.
	self deny: aBlockContext isPseudoContext.
	self assert: aBlockContext home = contextOfaBlockContext.
	self assert: aBlockContext receiver = self.
	self assert: (aBlockContext method isKindOf: CompiledMethod).
! !

!TimeTest methodsFor: 'Tests' stamp: 'laza 8/28/2009 00:28'!
testGeneralInquiries
	| now d t dt epsilon |

	"vm clocks seem to work differently across platforms, so an epsilon is required"
	epsilon := 1. "second"
	now  := self timeClass dateAndTimeNow.
	self 
		assert: now size = 2;
		assert: (now last asSeconds - self timeClass now asSeconds) abs <= epsilon.

	self should: [ self timeClass timeWords ] raise: MessageNotUnderstood.

	d := '2 June 1973' asDate.
	t := '4:02:47 am' asTime.
	dt := self timeClass dateAndTimeFromSeconds: (2285280000 + 14567).
	self
		assert: dt = {d. t.}.
! !

BlockContextTest removeSelector: #testFindContextSuchThat!
BlockContextTest removeSelector: #testValueWithExitBreak!
BlockContextTest removeSelector: #testTrace!
BlockContextTest removeSelector: #testSupplySameAnswerToAllQuestions!
BlockContextTest removeSelector: #testSupplySeveralAnswersToSeveralQuestions!
BlockContextTest removeSelector: #testBlockIsBottomContext!
BlockContextTest removeSelector: #testSupplyAnswerThroughNestedBlocks!
BlockContextTest removeSelector: #testValueWithArguments!
BlockContextTest removeSelector: #testCopyStack!
BlockContextTest removeSelector: #testSupplyAnswerUsingTraditionalMatchOfQuestion!
BlockContextTest removeSelector: #testTallyMethods!
BlockContextTest removeSelector: #testValueWithExitContinue!
