"Change Set:		7770System-ar.145

System-ar.145:
Fix up Preferences not to call UI methods on TextStyle.

System-ar.143:
More offList/suspend cleanup.

System-jmv.144:
 Remove the (now unused) #properAlphaForBlackText preference.

"!
!Preferences class methodsFor: 'fonts' stamp: 'ar 9/7/2009 15:00'!
setDefaultFonts: defaultFontsSpec
	"Since this is called from menus, we can take the opportunity to prompt for missing font styles."

	| fontNames map emphases |
	fontNames := defaultFontsSpec collect: [:array | array second].
	map := IdentityDictionary new.
	emphases := IdentityDictionary new.
	fontNames do: [:originalName | | decoded style |
		decoded := TextStyle decodeStyleName: originalName.
		style := map at: originalName put: (TextStyle named: decoded second).
		emphases at: originalName put: decoded first.
		style ifNil: [map at: originalName put: TextStyle default]].

	defaultFontsSpec do: [:triplet | self
		perform: triplet first
		with: (((map at: triplet second) fontOfPointSize: triplet third) emphasized: (emphases at: triplet second))]! !

!Project class methodsFor: 'utilities' stamp: 'ar 9/6/2009 11:04'!
interruptName: labelString preemptedProcess: theInterruptedProcess
	"Create a Notifier on the active scheduling process with the given label."
	| preemptedProcess projectProcess |
	Smalltalk isMorphic ifFalse:
		[^ ScheduledControllers interruptName: labelString].
	ActiveHand ifNotNil:[ActiveHand interrupted].
	ActiveWorld := World. "reinstall active globals"
	ActiveHand := World primaryHand.
	ActiveHand interrupted. "make sure this one's interrupted too"
	ActiveEvent := nil.

	projectProcess := self uiProcess.	"we still need the accessor for a while"
	preemptedProcess := theInterruptedProcess ifNil: [Processor preemptedProcess].
	"Only debug preempted process if its priority is >= projectProcess' priority"
	preemptedProcess priority < projectProcess priority 
		ifTrue:[preemptedProcess := projectProcess].
	preemptedProcess suspend.
	Debugger openInterrupt: labelString onProcess: preemptedProcess
! !

Preferences class removeSelector: #properAlphaForBlackText!
Preferences class removeSelector: #chooseFontWithPrompt:andSendTo:withSelector:highlight:!
Preferences class removeSelector: #chooseFontWithPrompt:andSendTo:withSelector:!
