"Change Set:		7832MorphicTests-nice.12

MorphicTests-nice.12:
Add a test for http://bugs.squeak.org/view.php?id=1035

Recipe:
1) Add a PolygonMorph in another Morph with a ProportionalLayout.
2) Resize the containing Morph

Result:
the PolygonMorph is lying outside its container...

MorphicTests-ar.9:
Project refactoring: Use MorphicProjects.

MorphicTests-ar.10:
Remove obsolete WorldWindow reference.

MorphicTests-rkrk.11:
Tests for FormCanvas>>frameAndFillRoundRect:radius:fillStyle:borderWidth:borderColor:. It raises errors in degenerate cases when fillStyle is more than a Color (e.g. a GradientFillStyle).

"!
TestCase subclass: #FormCanvasTest
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicTests-Support'!

MorphTest subclass: #PolygonMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicTests-Basic'!

!FormCanvasTest methodsFor: 'tests' stamp: 'rkrk 9/24/2009 03:34'!
testFrameAndFillDegenerateRoundRect01

	| fill canvas smallRect |
	fill := GradientFillStyle sample.
	canvas := FormCanvas extent: 100@100.
	canvas fillColor: Color black.
	smallRect := 0@0 corner: 20@20.
	self shouldnt: [
		canvas
			frameAndFillRoundRect: smallRect
			radius: smallRect width / 2 + 1
			fillStyle: fill
			borderWidth: 0
			borderColor: Color lightGray]
		raise: Error.! !

!FormCanvasTest methodsFor: 'tests' stamp: 'rkrk 9/24/2009 03:35'!
testFrameAndFillDegenerateRoundRect02

	| fill canvas smallRect |
	fill := GradientFillStyle sample.
	canvas := FormCanvas extent: 100@100.
	canvas fillColor: Color black.
	smallRect := 0@0 corner: 20@20.
	self shouldnt: [
		canvas
			frameAndFillRoundRect: smallRect
			radius: 0
			fillStyle: fill
			borderWidth: 0
			borderColor: Color lightGray]
		raise: Error.! !

!MCPTest methodsFor: 'tests' stamp: 'ar 9/19/2009 20:18'!
testIsSystemWindow
	"test isSystemWindow"
	self deny: Object new isSystemWindow.
	self assert: SystemWindow new isSystemWindow.! !

!MorphTest methodsFor: 'initialize-release' stamp: 'ar 9/18/2009 20:07'!
getWorld
	^ world
		ifNil: [world := MorphicProject new world]! !

!PolygonMorphTest methodsFor: 'bounds' stamp: 'nice 2/16/2008 02:31'!
testBoundsBug1035
	"This is a non regression test for http://bugs.squeak.org/view.php?id=1035
	PolygonMorph used to position badly when container bounds were growing"
	
	| submorph aMorph |
	
	submorph := (PolygonMorph
		vertices: {0@0. 100@0. 0@100}
		color: Color red borderWidth: 0 borderColor: Color transparent)
			color: Color red.

	submorph bounds. "0@0 corner: 100@100"

	aMorph := Morph new
		color: Color blue;
		layoutPolicy: ProportionalLayout new;
		addMorph: submorph
		fullFrame: (LayoutFrame fractions: (0.1 @ 0.1 corner: 0.9 @ 0.9)).

	submorph bounds. "0@0 corner: 100@100 NOT YET UPDATED"
	aMorph fullBounds. "0@0 corner: 50@40. CORRECT"
	submorph bounds. "5@4 corner: 45@36 NOW UPDATED OK"

	aMorph extent: 100@100.
	submorph bounds. "5@4 corner: 45@36 NOT YET UPDATED"
	aMorph fullBounds. "-10@-14 corner: 100@100 WRONG"
	submorph bounds. "-10@-14 corner: 70@66 NOW WRONG POSITION (BUT RIGHT EXTENT)"

	self assert: aMorph fullBounds = (0 @ 0 extent: 100@100).
	self assert: submorph bounds = (10 @ 10 corner: 90@90).
! !

