"Change Set:		7952Morphic-ar.211

Morphic-ar.211:
Merging Morphic-MAD.206, Morphic-MAD.210:

Small UI tweaks:
Lazy list now uses new selection color.
System Window label is grayed for non-active windows.
Pluggable Button Morphs were ignoring standardButtonFont preference.

Morphic-laza.209:
Remove the in transition initialization again

Morphic-MAD.210:
Pluggable Button Morphs were ignoring standardButtonFont preference.

"!
!PluggableButtonMorph methodsFor: 'accessing' stamp: 'MAD 10/10/2009 00:54'!
label: aStringOrTextOrMorph
	self label: aStringOrTextOrMorph font: Preferences standardButtonFont  ! !

!SystemWindow methodsFor: 'top window' stamp: 'MAD 10/8/2009 23:18'!
passivate
	"Make me unable to respond to mouse and keyboard"

	label ifNotNil: [label color: Color darkGray].
	self setStripeColorsFrom: self paneColorToUse.
	model modelSleep.

	"Control boxes remain active, except in novice mode"
	self submorphsDo: [:m |
		m == labelArea ifFalse:
			[m lock]].
	labelArea ifNotNil:
		[labelArea submorphsDo: [:m |
			(m == closeBox or: [m == collapseBox])
				ifTrue:
					[Preferences noviceMode ifTrue: [m lock]]
				ifFalse:
					[m lock]]]
		ifNil: "i.e. label area is nil, so we're titleless"
			[self adjustBorderUponDeactivationWhenLabeless].
! !

!SystemWindow methodsFor: 'top window' stamp: 'MAD 10/8/2009 23:18'!
activateWindow
	"Bring me to the front and make me able to respond to mouse and keyboard.
	Was #activate (sw 5/18/2001 23:20)"

	| oldTop outerMorph sketchEditor pal |
	outerMorph := self topRendererOrSelf.
	outerMorph owner ifNil: [^ self "avoid spurious activate when drop in trash"].
	oldTop := TopWindow.
	oldTop = self ifTrue: [^self].
	TopWindow := self.
	oldTop ifNotNil: [oldTop passivate].
	outerMorph owner firstSubmorph == outerMorph
		ifFalse: ["Bring me (with any flex) to the top if not already"
				outerMorph owner addMorphFront: outerMorph].
	self submorphsDo: [:m | m unlock].

	label ifNotNil: [label color: Color black].

	labelArea ifNotNil:
		[labelArea submorphsDo: [:m | m unlock].
		self setStripeColorsFrom: self paneColorToUse].
	self isCollapsed ifFalse:
		[model modelWakeUpIn: self.
		self positionSubmorphs.
		labelArea ifNil: [self adjustBorderUponActivationWhenLabeless]].

	(sketchEditor := self extantSketchEditor) ifNotNil:
		[sketchEditor comeToFront.
		(pal := self world findA: PaintBoxMorph) ifNotNil:
			[pal comeToFront]].
! !

!SystemProgressMorph methodsFor: 'private' stamp: 'laza 10/9/2009 15:21'!
freeSlot: number
	number > 0 ifTrue: [
		lock critical: [
			(bars at: number) delete.
			(labels at: number) delete.
			activeSlots := activeSlots - 1.
			activeSlots = 0
				ifTrue: [self delete]
				ifFalse: [self recenter]]]! !

!SystemProgressMorph methodsFor: 'private' stamp: 'laza 10/9/2009 15:20'!
recenter
	| position |
	"Put ourself in the center of the display"
	self align: self fullBounds center with: Display boundingBox center.
	"Check to see if labels are wider than progress bars. In that case do
	a centered instead of the default left aligned layout."
	position :=	self width > (Inset x * 2 + (self borderWidth * 2) + BarWidth)
					ifTrue: [#topCenter]
					ifFalse: [#leftCenter].
	self cellPositioning: position! !

!LazyListMorph methodsFor: 'drawing' stamp: 'MAD 10/8/2009 23:09'!
drawBackgroundForMulti: row on: aCanvas
	| selectionDrawBounds thisColor |
	"shade the background paler, if this row is selected, but not the current selected row"
	thisColor := selectedRow = row
				ifTrue: [Preferences menuSelectionColor]
				ifFalse: [Preferences menuSelectionColor muchLighter].
	selectionDrawBounds := self drawBoundsForRow: row.
	selectionDrawBounds := selectionDrawBounds intersect: self bounds.
	aCanvas fillRectangle: selectionDrawBounds color: thisColor! !

