"Change Set:		8082ST80-dtl.62

ST80-dtl.62:
Fix ScreenController>>openMenu which had menu separator lines in the wrong position, and which opened a Morphic project in response to 'open... ->mvc project'. This change restores the original menu structure, except that 'open... ->morphic project' and 'open... ->morphic world' are now displayed only if Morphic is present in the image, as per presumed intent of the prior change to #openMenu.

Open concerns: The 'open... -> keep this menu up' option, restored to the menu by this change, and 'open... ->mvc project' options, which now attempts to open an mvc (not morphic) project, are both badly broken and will cause image freeze. The 'open... ->file list' and 'open... ->morphic world' selections (not related to this menu change) are also broken, probably for the same reason.

ST80-dtl.61:
Add #defaultBackgroundColor (moved from Project to MVCProject)

"!
!ScreenController methodsFor: 'nested menus' stamp: 'dtl 10/31/2009 19:32'!
openMenuWithMorphicOptions
	"Include 'morphic world' and 'morphic project' selections"
	^ SelectionMenu labelList:
		#(	'keep this menu up'

			'browser'
			'package browser'
			'method finder'
			'workspace'
			'file list'
			'file...'
			'transcript'
			'morphic world'

			'simple change sorter'
			'dual change sorter'

			'mvc project'
			'morphic project'
			)
		lines: #(1 9 11)
		selections: #(durableOpenMenu
openBrowser openPackageBrowser openSelectorBrowser openWorkspace openFileList openFile openTranscript openMorphicWorld
openSimpleChangeSorter openChangeManager
openProject  openMorphicProject  )
"
ScreenController  new openMenuWithMorphicOptions startUp
"! !

!MVCProject methodsFor: 'initialize' stamp: 'dtl 10/31/2009 15:34'!
defaultBackgroundColor
	^ Color r: 1.0 g: 1.0 b: 0.065! !

!ScreenController methodsFor: 'nested menus' stamp: 'dtl 10/31/2009 19:27'!
openMenu
	"Smalltalk hasMorphic ifTrue: [^self openMenuWithMorphicOptions]."
	^ SelectionMenu labelList:
		#(	'keep this menu up'

			'browser'
			'package browser'
			'method finder'
			'workspace'
			'file list'
			'file...'
			'transcript'

			'simple change sorter'
			'dual change sorter'

			'new project'
			)
		lines: #(1 8 10)
		selections: #(durableOpenMenu
openBrowser openPackageBrowser openSelectorBrowser openWorkspace openFileList openFile openTranscript
openSimpleChangeSorter openChangeManager
openProject   )
"
ScreenController  new openMenu startUp
"! !

