"Change Set:		8172KernelTests-nice.108

KernelTests-nice.108:
move DependentsArrayTest from Kernel to KernelTests

"!
ClassTestCase subclass: #DependentsArrayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KernelTests-Objects'!

!DependentsArrayTest methodsFor: 'testing' stamp: 'nice 2/21/2007 23:11'!
testAddingTwice
	
	| test dep2 deps |
	test := Object new.
	dep2 := String with: $z with: $u with: $t.
	
	test addDependent: String new.
	test addDependent: dep2.
	
	Smalltalk garbageCollect. "this will make first dependent vanish, replaced by nil"
	
	test addDependent: dep2.
	
	deps := test dependents.
	self should: [deps asIdentitySet size = deps size] description: 'No object should be added twice in dependents'! !

!DependentsArrayTest methodsFor: 'testing' stamp: 'nice 2/9/2006 22:28'!
testCanDiscardEdits
	"self debug: #testCanDiscardEdits."

	| anObject aView  |
	anObject := Object new.
	aView := StringHolderView new
		model: Transcript;
		window: (0@0 extent: 60@60);
		borderWidth: 1.
	aView hasUnacceptedEdits: true.
	anObject addDependent: Object new. "this entry should be garbage collected"
	anObject addDependent: aView.

	Smalltalk garbageCollect. "force garbage collection"

	self
		should: [anObject dependents size = 1]
		description: 'first dependent of anObject should have been collected, second should not'.

	self
		shouldnt: [anObject canDiscardEdits]
		description: 'anObject cannot discard edits because aView is a dependent of anObject and aView has unaccepted edits'.! !

