"Change Set:		8303Multilingual-dtl.67

Multilingual-dtl.67:
Use Beeper class>>beep rather than deprecated Object>>beep

"!
!LanguageEditor methodsFor: 'gui methods' stamp: 'dtl 11/29/2009 21:25'!
addTranslation
	"translate a phrase"
	| phrase |
	phrase := UIManager default
				request: 'enter the original:'
				initialAnswer: ''.

	(phrase isNil
			or: [phrase = ''])
		ifTrue: [""
			Beeper beep.
			^ self].
	""
	self translatePhrase: phrase! !

!LanguageEditor methodsFor: 'gui methods' stamp: 'dtl 11/29/2009 21:26'!
translate
	"translate a phrase"
	| phrase |
	phrase := self phraseToTranslate.
	""
	(phrase isNil
			or: [phrase = ''])
		ifTrue: [""
			Beeper beep.
			^ self].
	""
	self translatePhrase: phrase! !

!LanguageEditor methodsFor: 'gui methods' stamp: 'dtl 11/29/2009 21:26'!
searchTranslation: aString 
	| translations results index |
	translations := self translations.
	results := translations
				select: [:each | ""
					('*' , aString , '*' match: each)
						or: ['*' , aString , '*' match: (self translator translationFor: each)]].
	""
	results isEmpty
		ifTrue: [""
			self inform: 'no matches for' translated , ' ''' , aString , ''''.
			^ self].
	""
	results size = 1
		ifTrue: [""
			self selectTranslationPhrase: results first.
			^ self].
	""
	index := (UIManager default 
				chooseFrom: (results
						collect: [:each | ""
							(each copy replaceAll: Character cr with: $\)
								, ' -> '
								, ((self translator translationFor: each) copy replaceAll: Character cr with: $\)])
				title: 'select the translation...' translated).
	""
	index isZero
		ifTrue: [""
			Beeper beep.
			^ self].
	""
	self
		selectTranslationPhrase: (results at: index)! !

!LanguageEditor methodsFor: 'gui methods' stamp: 'dtl 11/29/2009 21:25'!
saveToFile
	"save the translator to a file"
	| fileName |
	fileName := UIManager default request: 'file name' translated initialAnswer: translator localeID isoString , '.translation'.
	(fileName isNil
			or: [fileName isEmpty])
		ifTrue: [""
			Beeper beep.
			^ self].
	""
Cursor wait
		showWhile: [
	self translator saveToFileNamed: fileName]! !

!LanguageEditor methodsFor: 'gui methods' stamp: 'dtl 11/29/2009 21:25'!
removeTranslation
	"remove the selected translation"
	| translation |
	self selectedTranslation isZero
		ifTrue: [""
			Beeper beep.
			self inform: 'select the translation to remove' translated.
			^ self].
	""
	translation := self translations at: self selectedTranslation.
""
	(self
			confirm: ('Removing "{1}".
Are you sure you want to do this?' translated format: {translation}))
		ifFalse: [^ self].
""
	self translator removeTranslationFor: translation.
	self changed: #translations.
	self changed: #untranslated.! !

!LanguageEditor methodsFor: 'gui methods' stamp: 'dtl 11/29/2009 21:25'!
browseMethodsWithTranslation
	| translation |
	self selectedTranslation isZero
		ifTrue: [""
			Beeper beep.
			self inform: 'select the translation to look for' translated.
			^ self].
	""
	translation := self translations at: self selectedTranslation.
	self systemNavigation browseMethodsWithLiteral: translation! !

!LanguageEditor methodsFor: 'gui methods' stamp: 'dtl 11/29/2009 21:26'!
searchUntranslated
	| search |
	search := UIManager default request: 'search for' translated initialAnswer: ''.
	(search isNil
			or: [search isEmpty])
		ifTrue: [""
			Beeper beep.
			^ self].
	""
	self searchUntranslated: search! !

!LanguageEditor methodsFor: 'gui methods' stamp: 'dtl 11/29/2009 21:26'!
translatePhrase: aString 
	"translate aString"
	| translation |
	translation := UIManager default
				multiLineRequest: 'translation for: ' translated , '''' , aString , ''''
				centerAt: Sensor cursorPoint
				initialAnswer: aString
				answerHeight: 200.
	""
	(translation isNil
			or: [translation = ''])
		ifTrue: [""
			Beeper beep.
			^ self].
	""
	self phrase: aString translation: translation! !

!LanguageEditor methodsFor: 'gui methods' stamp: 'dtl 11/29/2009 21:25'!
loadFromFile
	| fileName |
	fileName := self selectTranslationFileName.
	fileName isNil
		ifTrue: [""
			Beeper beep.
			^ self].
	""
	Cursor wait
		showWhile: [
			self translator loadFromFileNamed: fileName.
			self changed: #translations.
			self changed: #untranslated]! !

!LanguageEditor methodsFor: 'gui methods' stamp: 'dtl 11/29/2009 21:25'!
mergeFromFile
	| fileName |
	fileName := self selectTranslationFileName.
	fileName isNil
		ifTrue: [""
			Beeper beep.
			^ self].
	""
	Cursor wait
		showWhile: [
			self translator loadFromFileNamed: fileName.
			self changed: #translations.
			self changed: #untranslated]! !

!LanguageEditor methodsFor: 'gui methods' stamp: 'dtl 11/29/2009 21:26'!
searchTranslation
	| search |
	search := UIManager default request: 'search for' translated initialAnswer: ''.
	(search isNil
			or: [search isEmpty])
		ifTrue: [""
			Beeper beep.
			^ self].
""
self searchTranslation: search! !

!LanguageEditor methodsFor: 'gui methods' stamp: 'dtl 11/29/2009 21:25'!
removeUntranslated
	"remove the selected untranslated phrase"
	| untranslated |
	self selectedUntranslated isZero
		ifTrue: [""
			Beeper beep.
			self inform: 'select the untranslated phrase to remove' translated.
			^ self].
	""
	untranslated := self untranslated at: self selectedUntranslated.
	""
	(self
			confirm: ('Removing "{1}".
Are you sure you want to do this?' translated format: {untranslated}))
		ifFalse: [^ self].
	""
	self translator removeUntranslated: untranslated! !

!LanguageEditor methodsFor: 'gui methods' stamp: 'dtl 11/29/2009 21:25'!
browseMethodsWithUntranslated
	| untranslated |
	self selectedUntranslated isZero
		ifTrue: [""
			Beeper beep.
			self inform: 'select the untranslated phrase to look for' translated.
			^ self].
	""
	untranslated := self untranslated at: self selectedUntranslated.
	SystemNavigation default browseMethodsWithLiteral: untranslated.
! !

!LanguageEditor methodsFor: 'gui methods' stamp: 'dtl 11/29/2009 21:26'!
searchUntranslated: aString 
	| untranslateds results index |
	untranslateds := self untranslated.
	results := untranslateds
				select: [:each | '*' , aString , '*' match: each].
	""
	results isEmpty
		ifTrue: [""
			self inform: 'no matches for' translated , ' ''' , aString , ''''.
			^ self].
	""
	results size = 1
		ifTrue: [""
			self selectUntranslatedPhrase: results first.
			^ self].
	""
	index := (UIManager default 
				chooseFrom: (results
						collect: [:each | each copy replaceAll: Character cr with: $\])
				title: 'select the untranslated phrase...' translated).
	""
	index isZero
		ifTrue: [""
			Beeper beep.
			^ self].
	""
	self
		selectUntranslatedPhrase: (results at: index)! !

