"Change Set:		8326Collections-ul.232

Collections-ul.232:
Part 1 of WeakIdentityKeyDictionary hash change.
Also removed previous preamble.

"!
!WeakIdentityKeyDictionary methodsFor: 'private' stamp: 'ul 12/1/2009 04:35'!
scanForEmptySlotFor: anObject
	"Scan the key array for the first slot containing an empty slot (indicated by a nil). Answer the index of that slot. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	| index start |
	index := start := anObject scaledIdentityHash \\ array size + 1.
	[ 
		(array at: index) ifNil: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!WeakIdentityKeyDictionary methodsFor: 'private' stamp: 'ul 12/1/2009 04:35'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or raise an error if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."

	| index start |
	CollectionRehashingUtility quickRehashBecause: #weakIdentityKeyDictionaryScanForChanged.
	index := start := anObject scaledIdentityHash \\ array size + 1.
	[ 
		| element |
		((element := array at: index) == nil or: [ element key == anObject ])
			ifTrue: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

