"Change Set:		8330System-ar.186

System-ar.186:
Merging System-ul.185:

Part 1 of SystemDictionary hash change (use #hash instead of #identityHash)

"!
!SystemDictionary methodsFor: 'private' stamp: 'ul 11/30/2009 05:13'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or raise an error if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."

	| index start |
	CollectionRehashingUtility quickRehashBecause: #systemDictionaryScanForChanged.
	index := start := anObject hash \\ array size + 1.
	[ 
		| element |
		((element := array at: index) == nil or: [ element key == anObject ])
			ifTrue: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!SystemDictionary methodsFor: 'private' stamp: 'ul 11/30/2009 05:14'!
scanForEmptySlotFor: anObject
	"Scan the key array for the first slot containing an empty slot (indicated by a nil). Answer the index of that slot. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	| index start |
	index := start := anObject hash \\ array size + 1.
	[ 
		(array at: index) ifNil: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

