"Change Set:		8719System-ar.214

System-ar.214:
- Flush all MC caches before updating. Solves problems when a previous update failed to load.
- Prepare to remove viewRegistry from Preference.

"!
!Preference class methodsFor: 'class initialization' stamp: 'ar 1/2/2010 23:43'!
initialize
	"Ensure that all preferences have their type set correctly before removing viewRegistry"
	self allSubInstancesDo:[:pref| pref type].
! !

!Utilities class methodsFor: 'fetching updates' stamp: 'ar 1/2/2010 23:45'!
updateFromServer
	"Update the image by loading all pending updates from the server."
	| config |
	"Flush all caches. If a previous download failed this is often helpful"
	MCFileBasedRepository flushAllCaches.
	config := MCMcmUpdater updateFromRepositories: #(
		'http://source.squeak.org/trunk'
	).
	self setSystemVersionFromConfig: config.
	self inform: 'Update completed.
Current update number: ', SystemVersion current highestUpdate.! !

Preference initialize!
