"Change Set:		8720Morphic-ar.280

Morphic-ar.280:
Time to take the plunge: The Cuis editors have been working great for a long time now, so switch to using them exclusively and remove the preference allowing to switch back (one can still switch back by changing the defaultEditorClass manually). Also, fixes one annoying incompatibility with Cuis editors namely that the default was not to allow selection shrinking.

"!
Object subclass: #Editor
	instanceVariableNames: 'sensor morph selectionShowing'
	classVariableNames: 'SelectionsMayShrink'
	poolDictionaries: ''
	category: 'Morphic-Text Support'!

!Editor class methodsFor: 'preferences' stamp: 'ar 1/2/2010 14:44'!
selectionsMayShrink: aBool
	SelectionsMayShrink := aBool.! !

!TextMorph class methodsFor: 'class initialization' stamp: 'ar 1/2/2010 14:47'!
initialize	"TextMorph initialize"

	"Initialize the default text editor class to use"
	DefaultEditorClass := SmalltalkEditor.

	"Initialize constants shared by classes associated with text display."

	CaretForm := (ColorForm extent: 16@5
					fromArray: #(2r001100e26 2r001100e26 2r011110e26 2r111111e26 2r110011e26)
					offset: -2@0)
					colors: (Array with: Color transparent with: Preferences textHighlightColor).

	self registerInFlapsRegistry.
! !

!Editor methodsFor: 'private' stamp: 'ar 1/2/2010 14:45'!
setIndices: shiftPressed forward: forward
	"Little helper method that sets the moving and fixed indices according to some flags."
	| indices |
	indices _ Dictionary new.
	(shiftPressed and:[self class selectionsMayShrink])
		ifTrue: [
			indices at: #moving put: self pointIndex.
			indices at: #fixed put: self markIndex
		] ifFalse: [
			forward
				ifTrue:[
					indices at: #moving put: self stopIndex.
					indices at: #fixed put: self startIndex.
				] ifFalse: [
					indices at: #moving put: self startIndex.
					indices at: #fixed put: self stopIndex.
				]
		].
	^indices! !

!Editor class methodsFor: 'preferences' stamp: 'ar 1/2/2010 14:45'!
selectionsMayShrink
	<preference: 'Selections may shrink'
		category: 'Morphic'
		description: 'When true, allows selection to shrink when using shift+cursor keys'
		type: #Boolean>
	^SelectionsMayShrink ifNil:[true]! !

TextMorph class removeSelector: #useNewEditors:!
TextMorph class removeSelector: #useNewEditors!
TextMorph initialize!
