"Change Set:		8928SMBase-nice.96

SMBase-nice.96:
Simplify some ( on: Error do:  ) patterns:
no non local return, nor outer temp required

SMBase-ul.95:
- code critics

"!
!SMSqueakMap class methodsFor: 'server detection' stamp: 'nice 1/18/2010 15:18'!
pingServer: aServerName
	"Check if the SqueakMap server is responding.
	For an old image we first make sure the name resolves -
	the #httpGet: had such a long timeout (and hanging?)
	for resolving the name."

	"Only test name lookup first if image is before the network rewrite,
	after the rewrite it works."
	^[ | answer url |
	(SystemVersion current highestUpdate < 5252)
		ifTrue: [NetNameResolver addressForName: (aServerName upTo: $:) timeout: 5].
	url := 'http://', aServerName, '/ping'.
	answer := HTTPSocket httpGet: url.
	answer isString not and: [answer contents = 'pong']]
		on: Error do: [ false ].
	! !

!SMAccount methodsFor: 'files' stamp: 'nice 1/12/2010 08:32'!
streamForFile: fileName
	"Return a readonly stream for file <fileName>.
	If the file does not exist return nil."

	^[StandardFileStream oldFileNamed: (self uploadsDirectory fullNameFor: fileName)]
		on: FileDoesNotExistException do: [nil]! !

!SMSqueakMap methodsFor: 'checkpoints' stamp: 'ul 1/11/2010 07:49'!
saveCheckpoint: contentWithFilename
	"Save the map checkpoint to disk if it is not there already."

	| directory sz fname content |
	directory := self directory.
	sz := contentWithFilename size.
	fname := contentWithFilename last: sz - (contentWithFilename lastIndexOf: $:).
	content := contentWithFilename first: sz - fname size - 1.
	(directory fileExists: fname) ifFalse: [
		StandardFileStream newFileNamed: (directory fullNameFor: fname) do: [ :file |
			file nextPutAll: content ] ]! !

