"Change Set:		9333Exceptions-ar.21

Exceptions-ar.21:
Introduce Exception>>defaultReturnValue and Exception>>defaultResumeValue to provide default values for argument-less #resume or #return. The motivation is that catch-all handler may not be aware of specific return / resume values required by some exceptions. The protocol allows these exceptions to provide a reasonable default value for those situations.

Exceptions-cmm.19:
- Do not allow messageText to answer nil.  Exceptions can be signaled with no mesageText, and yet almost no code, anywhere, assumes it can be nil, sometimes causing breakage.

Exceptions-ar.20:
Adds DuplicateVariableError to indicate that a (class, instance) variable is both used in superclass and subclass.

"!
Error subclass: #DuplicateVariableError
	instanceVariableNames: 'superclass variable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exceptions-Kernel'!

!DuplicateVariableError methodsFor: 'accessing' stamp: 'abc 2/12/2010 11:47'!
superclass: aClass
	"The superclass in which the variable is defined"
	superclass := aClass! !

!Exception methodsFor: 'defaults' stamp: 'ar 2/13/2010 15:20'!
defaultResumeValue
	"Answer the value that by default should be returned if the exception is resumed"
	^nil! !

!DuplicateVariableError methodsFor: 'accessing' stamp: 'abc 2/12/2010 11:48'!
variable: aString
	"Name of the duplicate variable"
	variable := aString! !

!DuplicateVariableError methodsFor: 'testing' stamp: 'abc 2/12/2010 11:56'!
isResumable
	^true! !

!Exception methodsFor: 'handling' stamp: 'ar 2/13/2010 15:20'!
resume
	"Return from the message that signaled the receiver."

	self resume: self defaultResumeValue! !

!DuplicateVariableError methodsFor: 'accessing' stamp: 'abc 2/12/2010 11:48'!
variable
	"Name of the duplicate variable"
	^variable! !

!Exception methodsFor: 'defaults' stamp: 'ar 2/13/2010 15:20'!
defaultReturnValue
	"Answer the value that by default should be returned if the exception is returned"
	^nil! !

!Exception methodsFor: 'handling' stamp: 'ar 2/13/2010 15:20'!
return
	"Return nil as the value of the block protected by the active exception handler."

	self return: self defaultReturnValue! !

!DuplicateVariableError methodsFor: 'accessing' stamp: 'abc 2/12/2010 11:47'!
superclass
	"The superclass in which the variable is defined"
	^superclass! !

!Exception methodsFor: 'printing' stamp: 'cmm 2/11/2010 21:15'!
messageText
	"Return an exception's message text."
	^ messageText ifNil: [ String empty ]! !

