"Change Set:		9383KernelTests-dtl.139

KernelTests-dtl.139:
Remove last MVC/Morphic explicit dependency

KernelTests-dtl.137:
Change DependentArrayTest>>testCanDiscardEdits to use a PluggableTextMorph if MVC StringHolderView is not available (i.e. if MVC has been unloaded)

KernelTests-dtl.138:
Fix cut and paste editing error in previous update.

"!
!DependentsArrayTest methodsFor: 'testing' stamp: 'dtl 2/14/2010 23:06'!
testCanDiscardEdits
	"self debug: #testCanDiscardEdits."

	| anObject aView  |
	anObject := Object new.
	(Smalltalk hasClassNamed: #StringHolderView)
		ifTrue: ["Use MVC view if available"
			aView := (Smalltalk at: #StringHolderView) new
				model: Transcript;
				window: (0@0 extent: 60@60);
				borderWidth: 1.]
		ifFalse: ["Otherwise use a Morphic view"
			aView := (Smalltalk at: #PluggableTextMorph) new model: Transcript].
	self assert: aView notNil. "require either a StringHolderView or PluggableTextMorph"
	aView := PluggableTextMorph new model: Transcript.
	aView hasUnacceptedEdits: true.
	anObject addDependent: Object new. "this entry should be garbage collected"
	anObject addDependent: aView.

	Smalltalk garbageCollect. "force garbage collection"

	self
		should: [anObject dependents size = 1]
		description: 'first dependent of anObject should have been collected, second should not'.

	self
		shouldnt: [anObject canDiscardEdits]
		description: 'anObject cannot discard edits because aView is a dependent of anObject and aView has unaccepted edits'.! !

