"Change Set:		9411ShoutCore-ar.8

ShoutCore-ar.8:
Allow shout to dynamically switch parsers when necessary (for example during debugging). Provide a hook that behaviors can implement to use an alternative shout parser class.

"!
!SHTextStylerST80 methodsFor: 'private' stamp: 'ar 2/19/2010 17:02'!
rangesIn: aText setWorkspace: aBoolean
	"Answer a collection of SHRanges by parsing aText.
	When formatting it is not necessary to set the workspace, and this can make the parse take less time, so aBoolean specifies whether the parser should be given the workspace"

	| shoutParserClass |
	"Switch parsers if we have to"
	shoutParserClass := (classOrMetaClass ifNil:[Object]) shoutParserClass.
	parser class = shoutParserClass ifFalse:[parser := shoutParserClass new].

	^parser 
		rangesIn: aText asString 
		classOrMetaClass: classOrMetaClass 
		workspace: (aBoolean ifTrue:[workspace])  
		environment: environment
! !

!Behavior methodsFor: '*ShoutCore-Parsing' stamp: 'ar 2/19/2010 17:02'!
shoutParserClass
	"Answer the parser class"
	^SHParserST80! !

