"Change Set:		9413Kernel-nice2.403

Kernel-nice2.403:
1) Introduce a Number class>>#readSqueakSyntaxFrom:  for Compiler/Scanner. This will later enable introduction of extended for #readFrom:
2) Connect the hook for allowing leading + sign in Integer reading.

This is a correction of Kernel-nice.403

"!
!Number class methodsFor: 'instance creation' stamp: 'nice 2/22/2010 21:41'!
readSqueakSyntaxFrom: stringOrStream 
	"Answer a number as described on aStream.  The number may
	be any accepted Smalltalk literal Number format.
	It can include a leading radix specification, as in 16rFADE.
	It can as well be NaN, Infinity or -Infinity for conveniency.
	If stringOrStream does not start with a valid number description, fail."
	
	^(SqNumberParser on: stringOrStream) nextNumber! !

!NumberParser methodsFor: 'parsing-public' stamp: 'nice 2/23/2010 15:21'!
nextIntegerBase: aRadix ifFail: aBlock
	"Form an integer with optional sign and following digits from sourceStream."
	
	| isNeg value |
	isNeg := self peekSignIsMinus.
	value := self nextUnsignedIntegerOrNilBase: aRadix.
	value isNil ifTrue: [^aBlock value].
	^isNeg
		ifTrue: [value negated]
		ifFalse: [value]! !

