"Change Set:		9414System-edc.259

System-edc.259:
Add CodeLoaderEnh as sended to list.

Examples os use:

| loader |
	loader _ CodeLoader new.
	loader baseURL: 'http://www.squeaksource.com/Ladrillos/'.
	loader loadSourceFiles: #('FFI-Kernel-ar.7.mcz' 'Network-IRC-fc.10.7.6.mcz');installSourceFiles.
	
	| loader |
	loader _ CodeLoader new.
	loader baseURL: 'http://www.squeaksource.com/MathMorphsRevival/'.
	loader loadSourceFiles: #('MorphicWrappers-edc.3.mcz' 'Functions-zz.4.mcz');installSourceFiles.
	




"!
!CodeLoader methodsFor: 'installing' stamp: 'edc 12/24/2008 10:26'!
lookLastVersion: packageName 
	| mcw montiNames package version |
	mcw := MCWorkingCopyBrowser new
				repository: (MCHttpRepository
						location: baseURL
						user: 'squeak'
						password: 'squeak').
	mcw repository
		ifNotNilDo: [:repos | montiNames := repos readableFileNames].
	package := montiNames
				detect: [:any | any beginsWith: packageName]
				ifNone: [].
	package
		ifNotNil: [Utilities
				informUser: 'Installing ' , packageName printString
				during: [version := mcw repository loadVersionFromFileNamed: package.
					version load]].
	MCPackageManager
		managersForCategory: packageName
		do: [:wc | wc repositoryGroup
				addRepository: (MCHttpRepository new location: baseURL)]! !

!CodeLoader methodsFor: 'installing' stamp: 'edc 9/17/2009 18:24'!
installMonticelloFor: aList 
	"Install the previously loaded source files"
	aList
		do: [:packName | self lookMonticelloVersion: packName].
	sourceFiles := nil! !

!CodeLoader methodsFor: 'accessing' stamp: 'edc 7/2/2008 10:37'!
segments
^ segments! !

!CodeLoader methodsFor: 'debugging' stamp: 'edc 7/10/2008 06:09'!
tryVersion: packageName 
| mcw montiNames package version |

mcw := MCWorkingCopyBrowser new repository: (MCHttpRepository
				location: baseURL
				user: ''
				password: '').
mcw repository ifNotNilDo: [:repos | montiNames := repos readableFileNames ].
	
	
	
	package := (montiNames detect:[:ea| ea beginsWith: packageName] ifNone:[] ) .
	package ifNotNil: [MCWorkingCopy allManagers do: [:each | 
		each  repositoryGroup
			addRepository: (MCHttpRepository new location: baseURL)]..
	version := mcw repository loadVersionFromFileNamed: package.
	version load].
^version! !

!CodeLoader methodsFor: 'installing' stamp: 'edc 2/20/2010 18:42'!
installSourceFiles
	"Install the previously loaded source files"
	| aSuffix | 
	sourceFiles == nil
		ifTrue: [^ self].
	sourceFiles
		do: [:req | aSuffix :=  (req url  findTokens: '.') last..
			
			aSuffix caseOf: {
			[ 'mcz'] -> [MczInstaller installStream: req contentStream].
				['sar'] ->[ SARInstaller new fileInFrom: req contentStream]}
				otherwise: [self installSourceFile: req contentStream]].
	sourceFiles := nil! !

!CodeLoader methodsFor: 'installing' stamp: 'edc 12/24/2008 08:15'!
installLastMonticelloFor: aList
	"Install the previously loaded source files"

	aList
		do: [:packName | 
			
					self lookLastVersion: packName].
	sourceFiles := nil! !

!CodeLoader methodsFor: 'installing' stamp: 'edc 9/17/2009 18:24'!
lookMonticelloVersion: packageName 
	| mcw montiNames package version |
	mcw := MCWorkingCopyBrowser new
				repository: (MCHttpRepository
						location: baseURL
						user: 'squeak'
						password: 'squeak').
	mcw repository
		ifNotNilDo: [:repos | montiNames := repos readableFileNames].
	package := montiNames
				detect: [:any | any = packageName]
				ifNone: [].
	package
		ifNotNil: [Utilities
				informUser: 'Installing ' , packageName printString
				during: [version := mcw repository loadVersionFromFileNamed: package.
					version load]].
	MCPackageManager
		managersForCategory: packageName
		do: [:wc | wc repositoryGroup
				addRepository: (MCHttpRepository new location: baseURL)]! !

