"Change Set:		9424Collections-ul.312

Collections-ul.312:
Finalization enhancement (part 1)
- use immediate finalization

Collections-ar.310:
Conversions from/to hex representations in ByteArray, for example:

	#[122 43 213 7] hex 
		=> '7a2bd507'

	ByteArray readHexFrom: '7a2bd507' 
		=> #[122 43 213 7]

Similarly these can be used for subclasses, e.g.,

	UUID new hex 
		=> '97c1f2ddf9209948b329319a30c16386'

	UUID readHexFrom: '97c1f2ddf9209948b329319a30c16386' 
		=> 97c1f2dd-f920-9948-b329-319a30c16386


"!
!ByteArray methodsFor: 'converting' stamp: 'ar 2/20/2010 12:44'!
hex
	"Answer a hexa decimal representation of the receiver"
	| string v index map |
	map := '0123456789abcdef'.
	string := String new: self size * 2. "hex"
	index := 0.
	1 to: self size do:[:i| 
		v := self at: i.
		string at: (index := index + 1) put: (map at: (v bitShift: -4) + 1). 
		string at: (index := index + 1) put: (map at: (v bitAnd: 15) + 1).
	].
	^string! !

!ByteArray methodsFor: 'initialize' stamp: 'ar 2/23/2010 07:08'!
readHexFrom: aStream
	"Initialize the receiver from a hexadecimal string representation"
	| map v ch value |
	map := '0123456789abcdef'.
	1 to: self size do:[:i|
		ch := aStream next.
		v := (map indexOf: ch) - 1.
		(v between: 0 and: 15) ifFalse:[^self error: 'Hex digit expected'].
		value := v bitShift: 4.
		ch := aStream next.
		v := (map indexOf: ch) - 1.
		(v between: 0 and: 15) ifFalse:[^self error: 'Hex digit expected'].
		value := value + v.
		self at: i put: value.
	].
! !

!WeakRegistry methodsFor: 'initialize' stamp: 'ul 2/22/2010 14:18'!
installFinalizer

	valueDictionary finalizer: #finalize! !

!ByteArray class methodsFor: 'instance creation' stamp: 'ar 2/23/2010 07:08'!
readHexFrom: aString
	"Create a byte array from a hexadecimal representation"
	^(self new: aString size // 2) readHexFrom: aString readStream! !

