"Change Set:		9514PackageInfo-Base-bp.41

PackageInfo-Base-bp.41:
Added linesOfCode for a package. Useful for estimating the size of a package.

PackageInfo-Base-bp.39:
Added packageName to PackageInfo printOn:

PackageInfo-Base-bp.40:
Fix typos

"!
!PackageInfo methodsFor: 'printing' stamp: 'bp 2/26/2010 20:37'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self packageName;
		nextPut: $)! !

!PackageInfo methodsFor: 'source code management' stamp: 'bp 2/26/2010 21:14'!
linesOfCode
	"An approximate measure of lines of code.
	Includes comments, but excludes blank lines."
	^self methods inject: 0 into: [:sum :each | sum + each compiledMethod linesOfCode]! !

!PackageInfo methodsFor: 'enumerating' stamp: 'bp 2/26/2010 20:47'!
allOverriddenMethodsDo: aBlock
	"Evaluates aBlock with all the overridden methods in the system"
	^ ProtoObject withAllSubclassesDo: [:class | 
		self overriddenMethodsInClass: class do: aBlock]
! !

!PackageInfo methodsFor: 'listing' stamp: 'bp 2/26/2010 20:45'!
allOverriddenMethods
	"search classes and meta classes"
	^ Array streamContents: [:stream |
		self allOverriddenMethodsDo: [:each | stream nextPut: each]]
! !

!PackageInfo methodsFor: 'enumerating' stamp: 'bp 2/26/2010 20:46'!
overriddenMethodsDo: aBlock
	"Enumerates the methods the receiver contains which have been overridden by other packages"
	^ self allOverriddenMethodsDo: [:ea |
		(self isOverrideOfYourMethod: ea)
			ifTrue: [aBlock value: ea]]! !

PackageInfo removeSelector: #allOverridenMethodsDo:!
PackageInfo removeSelector: #allOverridenMethods!
