"Change Set:		9544Kernel-dtl.414

Kernel-dtl.414:
Eliminate the 'special menu...' pick from StringHolder class>>shiftedYellowBottonMenuItems for Morphic Retain a hook for it in MVC.

Rationale: The special menu items selection is currently broken, but never did anything useful in Morphic AFICT. Best to just remove the option when not in MVC, but leave the MVC hook in hopes of fixing the original MVC implementation later (other MVC issues prevent this now).

This changes adds another #isMorphic send, which is undesirable. However, a number of menu construction methods already have this issue, so a general solution is needed for tailoring these menus to different project types.

"!
!StringHolder class methodsFor: 'yellow button menu' stamp: 'dtl 2/28/2010 13:14'!
shiftedYellowButtonMenuItems
	"Returns the standard yellow button menu items"
	| entries |
	entries := OrderedCollection withAll:
		{
			{'explain' translated.					#explain}.
			{'pretty print' translated.				#prettyPrint}.
			{'pretty print with color' translated.		#prettyPrintWithColor}.
			{'file it in (G)' translated.					#fileItIn}.
			{'spawn (o)' translated.					#spawn}.
			#-.
			{'browse it (b)' translated.				#browseIt}.
			{'senders of it (n)' translated.			#sendersOfIt}.
			{'implementors of it (m)' translated.		#implementorsOfIt}.
			{'references to it (N)' translated.			#referencesToIt}.
			#-.
			{'selectors containing it (W)' translated.	#methodNamesContainingIt}.
			{'method strings with it (E)' translated.	#methodStringsContainingit}.
			{'method source with it' translated.		#methodSourceContainingIt}.
			{'class names containing it' translated.	#classNamesContainingIt}.
			{'class comments with it' translated.		#classCommentsContainingIt}.
			{'change sets with it' translated.			#browseChangeSetsWithSelector}.
			#-.
			{'save contents to file...' translated.		#saveContentsInFile}.
			{'send contents to printer' translated.		#sendContentsToPrinter}.
			{'printer setup' translated.				#printerSetup}.
			#-.
		}.
	Smalltalk isMorphic ifFalse: [ entries add: 
			{'special menu...' translated.				#presentSpecialMenu}.].
	entries add:
			{'more...' translated.					#yellowButtonActivity}.
	^ entries! !

