"Change Set:		9577Tests-nice.55

Tests-nice.55:
Add a test for a Decompiler bug
(not solved yet)

Tests-ul.51:
- added a test for FileDirectory >> #=

Tests-ar.52:
Add PackageDependencyTest to document and track package dependencies.

Tests-ar.53:
Improved PackageDependencyTest now prints out dependencies upon failure so that we can see what the dependencies are and what we need to fix.

Tests-ar.54:
Add a test for the issue of terminating a well-behaved unwind block int he middle.

"!
TestCase subclass: #PackageDependencyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Dependencies'!

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:22'!
testToolBuilderSUnit
	self testPackage: 'ToolBuilder-SUnit' dependsOnlyOn: #(
		Collections
		Kernel
		ToolBuilder
		'ToolBuilder-Kernel'
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 20:58'!
testCompression
	self testPackage: 'Compression' dependsOnlyOn: #(
		Collections
		Exceptions
		Files
		Graphics
		Kernel
		Multilingual
		SUnit
		System
		'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:20'!
testSystem
	self testPackage: 'System' dependsOnlyOn: #(
		Collections
		Balloon
		Compiler
		Compression
		Exceptions
		Files
		Graphics
		Kernel
		Monticello
		MonticelloConfigurations
		Morphic
		MorphicExtras
		Multilingual
		Network
		PackageInfo
		Sound
		'ToolBuilder-Kernel'
		Tools
		TrueType
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:06'!
testMonticello
	self testPackage: 'Monticello' dependsOnlyOn: #(
		Collections
		Compiler
		Compression
		Exceptions
		Files
		Graphics
		Kernel
		Morphic
		Network
		PackageInfo
		System
		Tests
		'ToolBuilder-Kernel'
		'ToolBuilder-Morphic'
		Tools
	).! !

!ProcessTerminateBug methodsFor: 'tests' stamp: 'ar 3/3/2010 21:39'!
testTerminationDuringUnwind
	"An illustration of the issue of process termination during unwind.
	This uses a well-behaved unwind block that we should allow to complete
	if at all possible."
	| unwindStarted unwindFinished p |
	unwindStarted := unwindFinished := false.
	p := [[] ensure:[
			unwindStarted := true.
			Processor yield.
			unwindFinished := true.
		]] fork.
	self deny: unwindStarted.
	Processor yield.
	self assert: unwindStarted.
	self deny: unwindFinished.
	p terminate.
	self assert: unwindFinished.! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:20'!
testToolBuilder
	self testPackage: 'ToolBuilder-Kernel' dependsOnlyOn: #(
		Collections
		Files
		Graphics
		Kernel
		SUnit
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 20:40'!
testBalloon
	self testPackage: 'Balloon' dependsOnlyOn: #(
		Kernel Collections Graphics Morphic System
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:26'!
testMorphicExtras
	self testPackage: 'MorphicExtras' dependsOnlyOn: #(
		Balloon
		Collections
		Compiler
		Exceptions
		Files
		Graphics
		Kernel
		Morphic
		Network
		Sound
		System
		'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 20:55'!
testCollections
	self testPackage: 'Collections' dependsOnlyOn: #(
		Balloon
		Compiler
		Kernel
		Compression
		Exceptions
		Files
		Graphics
		Morphic
		MorphicExtras
		Multilingual
		Network
		System
		'ToolBuilder-Kernel'
	).! !

!DecompilerTests methodsFor: 'tests' stamp: 'nice 3/4/2010 22:26'!
testRemoteTemp
	| aBlock |
	aBlock := Compiler evaluate: '| x y |  [:a :b | x := a. y := b. x+y]'.
	self shouldnt: [aBlock decompile] raise: Error
	! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:18'!
testServices
	self testPackage: 'Services-Base' dependsOnlyOn: #(
		Collections
		Compiler
		Exceptions
		Graphics
		Kernel
		Morphic
		PackageInfo
		PreferenceBrowser
		System
		'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:21'!
testToolBuilderMorphic
	self testPackage: 'ToolBuilder-Morphic' dependsOnlyOn: #(
		Collections
		Exceptions
		Graphics
		Kernel
		Morphic
		System
		'ToolBuilder-Kernel'
		Tools
	).! !

!FileDirectoryTest methodsFor: 'tests' stamp: 'ul 2/28/2010 22:16'!
testEquality

	self assert: FileDirectory default = FileDirectory default.
	self deny: FileDirectory default = FileDirectory default containingDirectory.
	self deny: FileDirectory default = nil! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:23'!
testTrueType
	self testPackage: 'TrueType' dependsOnlyOn: #(
		Collections
		Balloon
		Exceptions
		Files
		Graphics
		Kernel
		Morphic
		Multilingual
		System
		'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:12'!
testMultilingual
	self testPackage: 'Multilingual' dependsOnlyOn: #(
		Collections
		Compiler
		Compression
		Exceptions
		Files
		Graphics
		Kernel
		Morphic
		Network
		System
		'ToolBuilder-Kernel'
		Tools
		TrueType
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:00'!
testEtoys
	self testPackage: 'EToys' dependsOnlyOn: #(
		Balloon
		Collections
		Compiler
		Exceptions
		Files
		Graphics
		Kernel
		Morphic
		MorphicExtras
		Network
		Protocols
		System
		'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:19'!
testSound
	self testPackage: 'Sound' dependsOnlyOn: #(
		Collections
		Balloon
		EToys
		Files
		Graphics
		Kernel
		Morphic
		MorphicExtras
		Network
		System
		'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:18'!
testShoutCore
	self testPackage: 'ShoutCore' dependsOnlyOn: #(
		Collections
		Graphics
		Kernel
		Monticello
		System
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:17'!
testSUnit
	self testPackage: 'SUnit' dependsOnlyOn: #(
		Collections
		Exceptions
		Kernel
		System
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:21'!
testToolBuilderMVC
	self testPackage: 'ToolBuilder-MVC' dependsOnlyOn: #(
		Collections
		Exceptions
		Graphics
		ST80
		ToolBuilder
		'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:14'!
testNetwork
	self testPackage: 'Network' dependsOnlyOn: #(
		Collections
		Compiler
		Compression
		Exceptions
		Files
		Graphics
		Kernel
		Morphic
		Multilingual
		System
		'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'utilities' stamp: 'ar 3/2/2010 20:19'!
testPackage: pkgName dependsOnlyOn: pkgList
	"Ensure that the package with the given name depends only on the packages in pkgList.
	NOTE: If you use this for fixing dependencies, classDeps includes the classes
	and users from the package(s) not declared as dependents. Basically, you need
	to fix all the references in classDeps to make the test pass."
	| classDeps pi pkgDeps |
	classDeps := IdentityDictionary new.
	pi := PackageOrganizer default packageNamed: pkgName ifAbsent:[^self]. "unloaded"
	pi classes do:[:pkgClass| 
		(classDeps at: (pkgClass superclass ifNil:[ProtoObject]) 
			ifAbsentPut:[OrderedCollection new]) add: pkgClass name, ' superclass'.
	].
	pi methods do:[:mref| | cm |
		cm := mref compiledMethod.
		1 to: cm numLiterals do:[:i| | lit |
			((lit := cm literalAt: i) isVariableBinding 
				and:[lit value isBehavior]) ifTrue:[(classDeps at: lit value ifAbsentPut:[OrderedCollection new]) add: cm methodClass asString, '>>', cm selector]]].
	pkgDeps := Dictionary new.
	classDeps keys do:[:aClass| | pkg |
		pkg := PackageOrganizer default packageOfClass: aClass ifNone:[nil].
		pkg ifNil:[
			Transcript cr; show: 'WARNING: No package for ', aClass.
			(classDeps removeKey: aClass) do:[:each| Transcript crtab; show: each].
		] ifNotNil:[
			(pkgDeps at: pkg name ifAbsentPut:[OrderedCollection new]) add: aClass.
		].
	].
	(pkgDeps removeKey: pkgName ifAbsent:[#()]) 
		do:[:aClass| classDeps removeKey: aClass ifAbsent:[]].
	pkgList do:[:pkg|
		self assert: (pkgDeps includesKey: pkg).
		(pkgDeps removeKey: pkg ifAbsent:[#()]) 
			do:[:aClass| classDeps removeKey: aClass ifAbsent:[]].
	].
	classDeps keysAndValuesDo:[:class :deps|
		Transcript cr; show: class name, ' dependencies:'.
		deps do:[:each| Transcript crtab; show: each].
	].
	self assert: pkgDeps isEmpty.
! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:25'!
testPackageInfo
	self testPackage: 'PackageInfo' dependsOnlyOn: #(
		Collections
		Compiler
		Graphics
		Kernel
		Morphic
		System
		'ToolBuilder-Kernel'
	).! !

!ExpandedSourceFileArrayTest methodsFor: 'testing' stamp: 'nice 1/16/2010 20:56'!
testCompatibilityWithStandardSourceFileArray
	"Test compatibility with StandardSourceFileArray across the address range of
	StandardSourceFileArray, including the unused address space below 16r1000000"
	
	| ssf esf i1 i2 p1 p2 a1 a2 |
	ssf := StandardSourceFileArray new.
	esf := ExpandedSourceFileArray new.
	0 to: 16rFFFFFF by: 811 do: [:e |
		i1 := ssf fileIndexFromSourcePointer: e.
		i2 := esf fileIndexFromSourcePointer: e.
		self assert: i1 = i2.
		self assert: i1 = 0. "This is unused address space"
		p1 := ssf filePositionFromSourcePointer: e.
		p2 := esf filePositionFromSourcePointer: e.
		self assert: p1 = p2].
	16r4FFFFFF to: 16r4FFFFFF by: 811 do: [:e |
		i1 := ssf fileIndexFromSourcePointer: e.
		i2 := esf fileIndexFromSourcePointer: e.
		self assert: i1 = i2.
		p1 := ssf filePositionFromSourcePointer: e.
		p2 := esf filePositionFromSourcePointer: e.
		self assert: p1 = p2.
		a1 := ssf sourcePointerFromFileIndex: i1 andPosition: p1.
		a2 := esf sourcePointerFromFileIndex: i2 andPosition: p2.
		self assert: a1 = a2.
		self assert: a1= e]

! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:09'!
testMorphic
	self testPackage: 'Morphic' dependsOnlyOn: #(
		Balloon
		Collections
		Compiler
		EToys
		Exceptions
		Files
		Graphics
		Kernel
		Monticello
		MonticelloConfigurations
		'Morphic-TrueType'			"????"
		MorphicExtras
		Multilingual
		Network
		PreferenceBrowser
		Protocols
		ST80
		Sound
		System
		'ToolBuilder-Kernel'
		'ToolBuilder-Morphic'
		Tools
		TrueType
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:24'!
testVersionNumber
	self testPackage: 'VersionNumber' dependsOnlyOn: #(
		Collections
		Kernel
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:02'!
testFiles
	self testPackage: 'Files' dependsOnlyOn: #(
		Collections
		Compression
		Exceptions
		Graphics
		Kernel
		Multilingual
		Network
		System
		'ToolBuilder-Kernel'
		Tools
	).! !

!ExpandedSourceFileArrayTest methodsFor: 'testing' stamp: 'nice 1/16/2010 20:56'!
testChangesFileAddressRange
	"Test file position to source pointer address translation for the changes file"
	
	| sf i p a a2 |
	sf := ExpandedSourceFileArray new.
	0 to: 16r1FFFFFFF by: 4093 do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		i := sf fileIndexFromSourcePointer: a.
		self assert: i == 2.
		p := sf filePositionFromSourcePointer: a.
		self assert: p = e.
		a2 := sf sourcePointerFromFileIndex: 2 andPosition: p.
		self assert: a2 = a].
	0 to: 16rFFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		self assert: (a between: 16r2000000 and: 16r2FFFFFF)].
	16r1000000 to: 16r1FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		self assert: (a between: 16r4000000 and: 16r4FFFFFF)].
	16r2000000 to: 16r2FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		self assert: (a between: 16r6000000 and: 16r6FFFFFF)].
	16r3000000 to: 16r3FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		self assert: (a between: 16r8000000 and: 16r8FFFFFF)].
	16r4000000 to: 16r4FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		self assert: (a between: 16rA000000 and: 16rAFFFFFF)].
	16r5000000 to: 16r5FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		self assert: (a between: 16rC000000 and: 16rCFFFFFF)].
	16r6000000 to: 16r6FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		self assert: (a between: 16rE000000 and: 16rEFFFFFF)].
	16r7000000 to: 16r7FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		self assert: (a between: 16r10000000 and: 16r10FFFFFF)]



! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 20:58'!
testCompiler
	self testPackage: 'Compiler' dependsOnlyOn: #(
		Collections
		Exceptions
		Graphics
		Kernel
		System
		'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:05'!
testKernel
	self testPackage: 'Kernel' dependsOnlyOn: #(
		Collections
		Compiler
		Compression
		Exceptions
		Files
		Graphics
		Morphic
		MorphicExtras
		Multilingual
		System
		'ToolBuilder-Kernel'
		Tools
		Traits
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:23'!
testTraits
	self testPackage: 'Traits' dependsOnlyOn: #(
		Collections
		Compiler
		Exceptions
		Files
		Kernel
		Monticello
		System
	).! !

!ExpandedSourceFileArrayTest methodsFor: 'testing' stamp: 'nice 1/16/2010 20:57'!
testSourcesFileAddressRange
	"Test file position to source pointer address translation for the sources file"
	
	| sf i p a a2 |
	sf := ExpandedSourceFileArray new.
	0 to: 16r1FFFFFFF by: 4093 do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		i := sf fileIndexFromSourcePointer: a.
		self assert: i == 1.
		p := sf filePositionFromSourcePointer: a.
		self assert: p = e.
		a2 := sf sourcePointerFromFileIndex: 1 andPosition: p.
		self assert: a2 = a].
	0 to: 16rFFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		self assert: (a between: 16r1000000 and: 16r1FFFFFF)].
	16r1000000 to: 16r1FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		self assert: (a between: 16r3000000 and: 16r3FFFFFF)].

	16r2000000 to: 16r2FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		self assert: (a between: 16r5000000 and: 16r5FFFFFF)].
	16r3000000 to: 16r3FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		self assert: (a between: 16r7000000 and: 16r7FFFFFF)].
	16r4000000 to: 16r4FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		self assert: (a between: 16r9000000 and: 16r9FFFFFF)].
	16r5000000 to: 16r5FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		self assert: (a between: 16rB000000 and: 16rBFFFFFF)].
	16r6000000 to: 16r6FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		self assert: (a between: 16rD000000 and: 16rDFFFFFF)].
	16r7000000 to: 16r7FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		self assert: (a between: 16rF000000 and: 16rFFFFFFF)]
! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:17'!
testSUnitGUI
	self testPackage: 'SUnitGUI' dependsOnlyOn: #(
		Collections
		Graphics
		Kernel
		PackageInfo
		SUnit
		System
		'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:15'!
testPreferenceBrowser
	self testPackage: 'PreferenceBrowser' dependsOnlyOn: #(
		Collections
		EToys
		Exceptions
		Graphics
		Kernel
		Morphic
		MorphicExtras
		System
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:24'!
testXML
	self testPackage: 'XML' dependsOnlyOn: #(
		Collections
		Exceptions
		Files
		Kernel
		Multilingual
		System
		Tests
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:10'!
testInstaller
	self testPackage: 'Installer' dependsOnlyOn: #(
		Collections
		Compression
		Exceptions
		Files
		Kernel
		Monticello
		MonticelloConfigurations
		Multilingual
		Network
		System
		'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:03'!
testGraphics
	self testPackage: 'Graphics' dependsOnlyOn: #(
		Collections
		Compression
		Exceptions
		Files
		Kernel
		Morphic
		MorphicExtras
		Multilingual
		Network
		System
		'ToolBuilder-Kernel'
		Tools
		TrueType
	).! !

!ExpandedSourceFileArrayTest methodsFor: 'testing' stamp: 'nice 1/16/2010 20:55'!
testAddressRange
	"Test source pointer to file position address translation across a wide address range"
	
	| sf i p a |
	sf := ExpandedSourceFileArray new.
	16r1000000 to: 16r10000000 by: 4093 do: [:e |
		i := sf fileIndexFromSourcePointer: e.
		p := sf filePositionFromSourcePointer: e.
		a := sf sourcePointerFromFileIndex: i andPosition: p.
		self assert: a = e]
! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:13'!
testNebraska
	self testPackage: 'Nebraska' dependsOnlyOn: #(
		Balloon
		Collections
		EToys
		Exceptions
		Files
		Graphics
		Kernel
		Morphic
		MorphicExtras
		Multilingual
		Network
		SUnit
		Sound
		System
		'ToolBuilder-Kernel'
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:22'!
testTools
	self testPackage: 'Tools' dependsOnlyOn: #(
		Collections
		Compiler
		Compression
		Exceptions
		Files
		Graphics
		Kernel
		Morphic
		MorphicExtras
		Multilingual
		Network
		PackageInfo
		ST80
		System
		'ToolBuilder-Kernel'
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:16'!
testST80
	self testPackage: 'ST80' dependsOnlyOn: #(
		Collections
		Compiler
		Exceptions
		Files
		Graphics
		Kernel
		Morphic
		Multilingual
		Network
		SUnit
		System
		'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:15'!
testProtocols
	self testPackage: 'Protocols' dependsOnlyOn: #(
		Collections
		Graphics
		Kernel
		Morphic
		MorphicExtras
		System
		'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ar 3/1/2010 21:00'!
testExceptions
	self testPackage: 'Exceptions' dependsOnlyOn: #(
		Collections
		Files
		Graphics
		Kernel
		Morphic
		System
	).! !

