"Change Set:		9671CollectionsTests-ar.156

CollectionsTests-ar.156:
Update base64 tests.

CollectionsTests-ar.155:
Update test to require Dictionary>>at: to raise KeyNotFound.

"!
!DictionaryTest methodsFor: 'basic tests' stamp: 'ar 3/9/2010 22:10'!
testAtError
	"self run: #testAtError"
	
	| dict |
	dict := Dictionary new.
	dict at: #a put: 666.
	self shouldnt: [ dict at: #a ] raise: KeyNotFound.
	self should: [ dict at: #b ] raise: KeyNotFound.
	
	! !

!Base64MimeConverterTest methodsFor: 'tests' stamp: 'ar 3/9/2010 22:19'!
testMimeEncodeDecode

	| encoded |
	encoded := Base64MimeConverter mimeEncode: message.
	self assert: (encoded contents = 'SGkgVGhlcmUh').
     self assert: ((Base64MimeConverter mimeDecodeToChars: encoded) contents = message contents).

	"Encoding should start from the beginning of the stream."
	message reset.
	message skip: 2.
	encoded := Base64MimeConverter mimeEncode: message.
	self assert: (encoded contents = 'SGkgVGhlcmUh').
	
	"Encoding should start from the current position of the stream."
	message reset.
	message skip: 2.
	encoded := Base64MimeConverter mimeEncodeContinue: message.
	self assert: (encoded contents = 'IFRoZXJlIQ==').! !

!Base64MimeConverterTest methodsFor: 'tests' stamp: 'ar 3/9/2010 22:21'!
testMimeEncodeDecodeMultiLine

	| encoded |
	encoded := (Base64MimeConverter mimeEncode: (String new: 100 withAll: $a) readStream) contents.
	self assert: encoded = 
'YWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFh
YWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYQ=='.

	encoded := (Base64MimeConverter mimeEncode: (String new: 100 withAll: $a) readStream multiLine: false) contents.
	self assert: encoded = 
'YWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYQ=='.
! !

